summaryrefslogtreecommitdiffstats
path: root/zsh/oh-my-zsh/plugins/colemak
diff options
context:
space:
mode:
authorLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2022-10-03 21:42:20 +0530
committerLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2022-10-03 21:42:20 +0530
commitaf120ab348f2e1a5a39dec035ed9dcf84189a64e (patch)
tree2a3aadd7ce1b7b771dfe3fe7c983569726c8d7ed /zsh/oh-my-zsh/plugins/colemak
downloaddotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.tar.gz
dotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.tar.bz2
dotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.zip
dotfiles
Diffstat (limited to 'zsh/oh-my-zsh/plugins/colemak')
-rw-r--r--zsh/oh-my-zsh/plugins/colemak/.gitignore1
-rw-r--r--zsh/oh-my-zsh/plugins/colemak/README.md48
-rw-r--r--zsh/oh-my-zsh/plugins/colemak/colemak-less6
-rw-r--r--zsh/oh-my-zsh/plugins/colemak/colemak.plugin.zsh38
4 files changed, 93 insertions, 0 deletions
diff --git a/zsh/oh-my-zsh/plugins/colemak/.gitignore b/zsh/oh-my-zsh/plugins/colemak/.gitignore
new file mode 100644
index 0000000..8241f5e
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/colemak/.gitignore
@@ -0,0 +1 @@
+.less
diff --git a/zsh/oh-my-zsh/plugins/colemak/README.md b/zsh/oh-my-zsh/plugins/colemak/README.md
new file mode 100644
index 0000000..4da4bc1
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/colemak/README.md
@@ -0,0 +1,48 @@
+# Colemak plugin
+
+This plugin remaps keys in `zsh`'s [`vi`-style navigation mode](http://zsh.sourceforge.net/Doc/Release/Zsh-Line-Editor.html#Keymaps)
+for a [Colemak](https://colemak.com/) keyboard layout, to match the QWERTY position:
+
+![Colemak layout on a US keyboard](https://colemak.com/wiki/images/6/6c/Colemak2.png)
+
+To use it, add it to the plugins array in your `~/.zshrc` file:
+
+```
+plugins=(... colemak)
+```
+
+You will also need to enable `vi` mode, so add another line to `~/.zshrc`:
+```
+bindkey -v
+```
+
+Restart your shell and hit the `<ESC>` key to activate `vicmd` (navigation) mode,
+and start navigating `zsh` with your new keybindings!
+
+## Key bindings for vicmd
+
+| Old | New | Binding | Description |
+|------------|------------|---------------------------|----------------------------------------------------|
+| `CTRL`+`j` | `CTRL`+`n` | accept-line | Insert new line |
+| `j` | `n` | down-line-or-history | Move one line down or command history forwards |
+| `k` | `e` | up-line-or-history | Move one line up or command history backwards |
+| `l` | `i` | vi-forward-char | Move one character to the right |
+| `n` | `k` | vi-repeat-search | Repeat command search forwards |
+| `N` | `K` | vi-rev-repeat-search | Repeat command search backwards |
+| `i` | `u` | vi-insert | Enter insert mode |
+| `I` | `U` | vi-insert-bol | Move to first non-blank char and enter insert mode |
+| `<none>` | `l` | vi-undo-change | Undo change |
+| `J` | `N` | vi-join | Join the current line with the next one |
+| `e` | `j` | vi-forward-word-end | Move to the end of the next word |
+| `E` | `J` | vi-forward-blank-word-end | Move to end of the current or next word |
+
+## Key bindings for less
+
+| Keyboard shortcut | `less` key binding |
+|-------------------|--------------------|
+| `n` | forw-line |
+| `e` | back-line |
+| `k` | repeat-search |
+| `ESC`+`k` | repeat-search-all |
+| `K` | reverse-search |
+| `ESC`+`K` | reverse-search-all |
diff --git a/zsh/oh-my-zsh/plugins/colemak/colemak-less b/zsh/oh-my-zsh/plugins/colemak/colemak-less
new file mode 100644
index 0000000..e4ca4fa
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/colemak/colemak-less
@@ -0,0 +1,6 @@
+n forw-line
+e back-line
+k repeat-search
+\ek repeat-search-all
+K reverse-search
+\eK reverse-search-all
diff --git a/zsh/oh-my-zsh/plugins/colemak/colemak.plugin.zsh b/zsh/oh-my-zsh/plugins/colemak/colemak.plugin.zsh
new file mode 100644
index 0000000..e6a46f2
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/colemak/colemak.plugin.zsh
@@ -0,0 +1,38 @@
+# ctrl-j newline
+bindkey '^n' accept-line
+bindkey -a '^n' accept-line
+
+# another rotation to match qwerty
+bindkey -a 'n' down-line-or-history
+bindkey -a 'e' up-line-or-history
+bindkey -a 'i' vi-forward-char
+
+# make qwerty
+bindkey -a 'k' vi-repeat-search
+bindkey -a 'K' vi-rev-repeat-search
+bindkey -a 'u' vi-insert
+bindkey -a 'U' vi-insert-bol
+bindkey -a 'l' vi-undo-change
+bindkey -a 'N' vi-join
+
+# spare
+bindkey -a 'j' vi-forward-word-end
+bindkey -a 'J' vi-forward-blank-word-end
+
+# Handle $0 according to the standard:
+# https://zdharma-continuum.github.io/Zsh-100-Commits-Club/Zsh-Plugin-Standard.html
+0="${${ZERO:-${0:#$ZSH_ARGZERO}}:-${(%):-%N}}"
+0="${${(M)0:#/*}:-$PWD/$0}"
+
+# New less versions will read this file directly
+export LESSKEYIN="${0:h:A}/colemak-less"
+
+# Only run lesskey if less version is older than v582
+less_ver=$(less --version | awk '{print $2;exit}')
+autoload -Uz is-at-least
+if ! is-at-least 582 $less_ver; then
+ # Old less versions will read this transformed file
+ export LESSKEY="${0:h:A}/.less"
+ lesskey -o "$LESSKEY" "$LESSKEYIN" 2>/dev/null
+fi
+unset less_ver